#include "ros/ros.h"
#include "std_msgs/Int16.h"
#include <sstream>
#include "iostream"
#include "opencv2/opencv.hpp"
#include <sensor_msgs/Image.h>
#include <sensor_msgs/image_encodings.h>
#include <image_transport/image_transport.h>
#include <opencv2/highgui/highgui.hpp>
#include <opencv2/imgproc/imgproc.hpp>
#include <cv_bridge/cv_bridge.h>

using namespace cv;
using namespace std;
int color = 0;
cv::Scalar RedLow = cv::Scalar(170, 140, 160);
cv::Scalar RedHigh = cv::Scalar(180, 255, 255);
cv::Scalar BlueLow = cv::Scalar(100, 150, 150);
cv::Scalar BlueHigh = cv::Scalar(140, 255, 255);
std::vector < std::vector < cv::Point>> contours;

int main(int argc, char** argv){
  float x,y,w,h = 0;
  bool flag = false;
  cv_bridge::CvImage img_bridge;
  sensor_msgs::Image img_msg;
  Mat video;
  Mat edg;
  Mat mask;
  Mat edg2[3];
  // Rect roi(0, 240, 640, 20);
  VideoCapture cap(2);

  cout<<"Wight = "<<cap.get(CAP_PROP_FRAME_WIDTH)<<endl;
  cout<<"Height = "<<cap.get(CAP_PROP_FRAME_HEIGHT)<<endl;
    //  Canny(edg, edg, 30, 70);s

  ros::init(argc, argv, "image_publisher");
  ros::NodeHandle nh;
  image_transport::ImageTransport it(nh);
  image_transport::Publisher pub = it.advertise("image/camera", 1);
  sensor_msgs::ImagePtr msg;
  ros::Rate loop_rate(5);

  while (true){
    cap >> video;
    cv::cvtColor(video, edg, cv::COLOR_BGR2HSV);
    if (color == 0)
      cv::inRange(edg, RedLow, RedHigh, mask);
    else
      cv::inRange(edg, BlueLow, BlueHigh, mask);
    cv::findContours(mask, contours, cv::RETR_EXTERNAL, cv::CHAIN_APPROX_SIMPLE);
    //cv::drawContours(video, contours, -1, (0, 255, 0), 3);
    for (size_t i = 0; i < contours.size(); i++) {
      cv::Rect boundRect = cv::boundingRect(contours[i]);
      if (boundRect.width > 40 and boundRect.height > 20) 
        ROS_INFO("x = %i\n", boundRect.x);
        if (flag == true){
          if (boundRect.width > 100){
            cv::rectangle(video, boundRect.tl(), boundRect.br(), (255 , 0, 0), 3);
            cv::line(video, boundRect.tl(), boundRect.br(), (255, 0, 0), 4);
          }
        }else{
          cv::rectangle(video, boundRect.tl(), boundRect.br(), (0 , 0, 0), 3);
          cv::line(video, boundRect.tl(), boundRect.br(), (0, 0, 0), 4);
          if ((boundRect.x+boundRect.width/2) > 310 and (boundRect.x+boundRect.width/2) < 330){
            cv::line(video, cv::Point(310, 0), cv::Point(310, 640), (0, 0, 255), 4);
            cv::line(video, cv::Point(330, 0), cv::Point(330, 640), (0, 0, 255), 4);
            flag = true;
          }else {
            cv::line(video, cv::Point(310, 0), cv::Point(310, 640), (0, 0, 0), 4);
            cv::line(video, cv::Point(330, 0), cv::Point(330, 640), (0, 0, 0), 4);
          }
        }
    }
    cv::cvtColor(video, video, cv::COLOR_BGR2RGB);
    msg = cv_bridge::CvImage(std_msgs::Header(), "bgr8", video).toImageMsg(); 
    pub.publish(msg);
  }      
  ros::spinOnce();
  loop_rate.sleep();
}
